<?php

using System;
using Gtk;
using Gdk;

MainClass::Main();

class MainClass {

	private static $add_png;
	private static $darea;
	private static $pixmap;
	private static $pngbuf;
	private static $rand;
		
	public static function Main() {
		self::$rand = new Random();		
		Application::Init();
		
		self::$pngbuf = new Pixbuf("monkey.png");
		
		$w = new Gtk::Window("Graphics Demo");

		$v = new VBox();
		$v->BorderWidth = 6;
		$v->Spacing = 12;
		$w->Add($v);
		
		self::$darea = new DrawingArea();
		self::$darea->SetSizeRequest(400, 400);
		add_event(self::$darea, "ExposeEvent", new ExposeEventHandler(null, Expose_Event));
		add_event(self::$darea, "ConfigureEvent", new ConfigureEventHandler(null, Configure_Event));
		$v->PackStart(self::$darea);
		
		$h = new HBox();
		self::$add_png = new Button("Add _Primate");
		add_event(self::$add_png, "Clicked", new EventHandler(null, AddPng_Clicked));
		$h->PackStart(self::$add_png, false, false, 0);
		$v->PackEnd($h, false, false, 0);
		
		$w->ShowAll();
		$w->Resizable = false;
		add_event($w, "DeleteEvent", new DeleteEventHandler(null, Window_Delete));
		
		Application::Run();
	}
	
	static function PlacePixbuf($buf) {
		$allocation = self::$darea->Allocation;
		$x = self::$rand->Next($allocation->Width) - $buf->Width / 2;
		$y = self::$rand->Next($allocation->Height) - $buf->Height / 2;
		self::$pixmap->DrawPixbuf(self::$darea->Style->BlackGC, $buf, 0, 0, $x, $y, $buf->Width, $buf->Height, RgbDither::None, 0, 0);
		self::$darea->QueueDrawArea($x, $y, $buf->Width, $buf->Height);
	}
	
	static function AddPng_Clicked($o, EventArgs $args) {
		$scale = self::$rand->Next(3) + 1;
		self::PlacePixbuf(self::$pngbuf->ScaleSimple(self::$pngbuf->Width / $scale, self::$pngbuf->Height / $scale, InterpType::Hyper));
	}

	static function Configure_Event($o, ConfigureEventArgs $args) {
		$ev = $args->Event;
		$window = $ev->Window;
		$allocation = self::$darea->Allocation;
		self::$pixmap = new Pixmap($window, $allocation->Width,	$allocation->Height, -1);
		self::$pixmap->DrawRectangle(self::$darea->Style->WhiteGC, true, 0, 0, $allocation->Width, $allocation->Height);
	}

	static function Expose_Event($o, ExposeEventArgs $args) {
		$area = $args->Event->Area;
		$args->Event->Window->DrawDrawable(self::$darea->Style->WhiteGC, self::$pixmap, $area->X, $area->Y, $area->X, $area->Y, $area->Width, $area->Height);
	}

	static function Window_Delete($o, DeleteEventArgs $args) {
		Application::Quit();
		$args->RetVal = true;
	}

}

?>