<?php

using System;
using Gtk;

MainClass::Main();

class MainClass {

	private static $firstname_entry, $lastname_entry, $email_entry;
		
	public static function Main() {
		Application::Init();
		self::SetUpGui();
		Application::Run();
	}
	
	static function SetUpGui() {
		$w = new Window("Sign up");

		self::$firstname_entry = new Entry();
		self::$lastname_entry = new Entry();
		self::$email_entry = new Entry();		

		$outerv = new VBox();
		$outerv->BorderWidth = 12;
		$outerv->Spacing = 12;
		$w->Add($outerv);
		
		$l = new Label("<span weight=\"bold\" size=\"larger\">" . "Enter your name and preferred address</span>");
		$l->Xalign = 0;
		$l->UseMarkup = true;
		$outerv->PackStart($l, false, false, 0);

		$h = new HBox();
		$h->Spacing = 6;
		$outerv->Add($h);
		
		$v = new VBox();
		$v->Spacing = 6;
		$h->PackStart($v, false, false, 0);
		
		$l = new Label("_First name:");
		$l->Xalign = 0;
		$v->PackStart($l, true, false, 0);
		$l->MnemonicWidget = self::$firstname_entry;
		
		$l = new Label("_Last name:");
		$l->Xalign = 0;
		$v->PackStart($l, true, false, 0);
		$l->MnemonicWidget = self::$lastname_entry;

		$l = new Label("_Email address:");
		$l->Xalign = 0;
		$v->PackStart($l, true, false, 0);
		$l->MnemonicWidget = self::$email_entry;

		$v = new VBox();
		$v->Spacing = 6;
		$h->PackStart($v, true, true, 0);

		$v->PackStart(self::$firstname_entry, true, true, 0);
		$v->PackStart(self::$lastname_entry, true, true, 0);
		$v->PackStart(self::$email_entry, true, true, 0);

		// hook up handlers
		add_event(self::$firstname_entry, "Changed", new EventHandler(null, Name_Changed));
		add_event(self::$lastname_entry, "Changed", new EventHandler(null, Name_Changed));
		add_event($w, "DeleteEvent", new DeleteEventHandler(null, Window_Delete));
		$w->ShowAll();
	}
	
	static function Window_Delete($o, DeleteEventArgs $args) {
		Application::Quit();
		$args->RetVal = true;
	}

	static function Name_Changed($o, EventArgs $args) {
		$e = self::$firstname_entry->Text->ToLower() . "." . self::$lastname_entry->Text->ToLower() . "@example.net";
		self::$email_entry->Text = $e->Replace(" ", "_");
	}

}

?>